/*
 *      Program do przegladania logow z ekg.
 *      Wyszukiwanie stringa w wiadomosciach.
 *
 *
 *      copyright (c) 2003 by Lukasz Bartnik
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __COMMAND_FIND_HH__
#define __COMMAND_FIND_HH__

#include "command.hh"
#include "errors.hh"
#include "mainwin.hh"
#include "dbase.hh"
#include "help.hh"




struct found_string_exception : public command_exception, public ekglog_exception {
    found_string_exception(int a, int b, int c):log(a),chat(b),msg(c) {}

    int log,chat,msg;
};

class ui_t;
class command_find : public command_base {
public:

    command_find(const std::string &str, std::vector<std::string> &events,
		 mainwin *mw, dbase_t *db, ui_t *ui)
	:command_base(str, events),_mw(mw),_db(db),_ui(ui) {}

    virtual ~command_find() {}
    virtual std::string help_short(void);
    virtual std::string help_long(void);
    virtual const std::vector<std::string>& completition(void);
    virtual const std::vector<std::string> &complete(const std::string &arg);

    virtual void run(const std::vector<std::string> &argv);

private:
    mainwin *_mw;
    dbase_t *_db;
    ui_t *_ui;

    static struct lf { 
	lf():log(0), chat(0), msg(0), offset(0) {}
	int log, chat, msg, offset;
	std::string str;
    } _last_find;
};

#endif /* __COMMAND_FIND_HH__ */
